from keras import *

(X_train, y_train), (X_test, y_test) = datasets.mnist.load_data()

X_train = X_train.reshape((-1,28,28,1)).astype('float32')/255
X_test = X_test.reshape((-1,28,28,1)).astype('float32')/255

y_train = utils.np_utils.to_categorical(y_train, 10)
y_test = utils.np_utils.to_categorical(y_test, 10)

inputs = layers.Input(shape=(28,28,1))

x = layers.Conv2D(32, kernel_size=(3,3), activation='relu')(inputs)
x = layers.Conv2D(64, (3,3), activation='relu')(x)
x = layers.MaxPooling2D(pool_size=(2,2))(x)
x = layers.Dropout(0.25)(x)
x = layers.Flatten()(x)
x = layers.Dense(128, activation='relu')(x)
x = layers.Dropout(0.5)(x)
x = layers.Dense(10, activation='softmax')(x)
model = models.Model(inputs, x)
model.compile(loss=losses.categorical_crossentropy, optimizer=optimizers.Adadelta(), metrics=['accuracy'])
history = model.fit(X_train, y_train, batch_size=128, epochs=12, verbose=1, validation_data=(X_test, y_test))

print("Model performance: {}".format(model.evaluate(X_test, y_test)))

from numpy.random import choice
p = 0.25
flips = [(choice(range(28), int(28*28*p)), choice(range(28), int(28*28*p))) for _ in range(X_snp.shape[0])]
for i in range(X_snp.shape[0]):
    X_snp[i, flips[i][0], flips[i][1], 0] = 1-X_snp[i, flips[i][0], flips[i][1], 0]

print("Corrupting by {}% using binary flips.".format(p))

print("Corrupted performance: {}".format(model.evaluate(X_snp, y_test)))

#model.save("trained_model.hdf5")

import scipy.misc
scipy.misc.imsave('snp0.png', X_snp[0,:,:,0])




(X_train, y_train), (X_test, y_test) = datasets.mnist.load_data()

X_train = X_train.reshape((-1,28,28,1)).astype('float32')/255
X_test = X_test.reshape((-1,28,28,1)).astype('float32')/255

y_train = utils.np_utils.to_categorical(y_train, 10)
y_test = utils.np_utils.to_categorical(y_test, 10)

inputs = layers.Input(shape=(28,28,1))

x = layers.Conv2D(32, kernel_size=(3,3), activation='relu')(inputs)
x = layers.Conv2D(64, (3,3), activation='relu')(x)
x = layers.MaxPooling2D(pool_size=(2,2))(x)
x = layers.Dropout(0.25)(x)
x = layers.Flatten()(x)
x = layers.Dense(128, activation='relu')(x)
x = layers.Dropout(0.5)(x)
x = layers.Dense(10, activation='softmax')(x)
model = models.Model(inputs, x)
model.compile(loss=losses.categorical_crossentropy, optimizer=optimizers.Adadelta(), metrics=['accuracy'])
history = model.fit(X_train, y_train, batch_size=128, epochs=12, verbose=1, validation_data=(X_test, y_test))

print("Model performance: {}".format(model.evaluate(X_test, y_test)))

from numpy.random import choice
p = 0.25
flips = [(choice(range(28), int(28*28*p)), choice(range(28), int(28*28*p))) for _ in range(X_snp.shape[0])]
for i in range(X_snp.shape[0]):
    X_snp[i, flips[i][0], flips[i][1], 0] = 1-X_snp[i, flips[i][0], flips[i][1], 0]
















